--NpCkeyData Ver 14Aug13 2330, updated 21Aug13 1600 (decimal pt mod)
--Program shows frequency or code digits directly on radio panel
--Must enter first Com or Nav digit (a 1)
--Added Reset function 22Aug13
-- 25 Aug13, Uses temp freq digits to avoid no response from FSX do to freq to far out of limits
-- FSUIPC ipcPARAM parameter values: 
	--10 is decimal point
	--11 is Com, Nav or ADF standby frequency swap
	--12 is BackSpace 
	--13 is NumPadControl On/OFF
	--14 is Reset active radio to first digit position
--27Aug1430 added altitude, heading and vertical speed entries for autopilot
    -- 15 is Vertical Speed Up
    -- 16 is Vertical Speed Down		
--19Sept2013 added OBS setting function
--14Nov2013 added Airspeed function for Autopilot to support AutoThrottle
--Al Klayton, 14Nov2013
 -- 15Sept14  Includes update for Flight1 KA B200 AP Altitude Select function.  
-- 1Dec14  File modified to handle multiple a/c: FSX default, Flight1 KA B200, PMDG 737NGX
-- 28Jan15  Added in PMDG B777
-- For A2A Cherokee AP
       -- 20 is Mode
	   -- 21 is Altitude Hold
	   -- 22 is AP Disconnect
	   
onoff = ipc.get("ONOFF")
acr = ipc.get("ACTIVE_RADIO") 
keypos = ipc.get("KEY_POS")                                                        --First key postion is Most Significant Digit, MSD)
aircraft_sel = ipc.get("CURR_AIRCRAFT")
param13=ipc.get("PARAM13")                                                          -- Aircraft selection value

-----------------------------------------------------------------------------------------
tab="\t\t\t\t\t\t\t\t\t\t\t\t\t\t"   -- tab is used to position NpC "messages" along the green bar
if onoff == nil then 
  ipc.set("ONOFF", "ON")                                                         --turn ON NumPadControl (NpC) as default
end
 if aircraft_sel == nil or (aircraft_sel ~= "*")and(aircraft_sel ~= "1")and(aircraft_sel ~= "2")and(aircraft_sel ~= "3")and(aircraft_sel ~= "4")and(aircraft_sel ~= "5") then   --aircraft_sel is non valid value
    aircraft_sel = "1"                                                      -- default to FSX default aircraft
 end
 
 if ipcPARAM == 13 then                                                             -- NumPadRadio Off and a/c selection menu code  
	--acr= nil                                                                  -- "clear" active radio value since selecting new a/c; all scripts should handle acr nil case
	ipc.set("ACTIVE_RADIO", nil)
	if param13 == nil then                                                   -- if param13 nil, use selection menu to pick a/c or turn NpC off
		ipc.set("ONOFF", "ON")                                                    -- so next "13" entry turns NpC off
        aircraft_sel=ipc.ask("Select (followed by Enter): \n  1  FSX Default or Std Add-on A/C\n  2  A2A Cherokee 180\n  3  FLIGHT1 KA B200\n  4  PMDG B737 NGX\n  5  PMDG B777\n  *  NpC Off",1) -- get a/c selection as STRING value
		aircraft_sel_num=tonumber(aircraft_sel)                              -- for input check below convert the string aircraft_sel to a number,  if not possible result is nil. 
		if aircraft_sel == "*" then	                                         -- if *, want to turn NpC off	                                                             
	    	ipc.set("PARAM13", nil)
			ipc.writeSTR(0x3380, tab.."Numpad Control " .. "** OFF **")                       -- since onoff must == "OFF"
		    ipc.writeSW(0x32FA, 4) 		                                                 --display for 4 sec NpC is off
		    ipc.set("ONOFF", "OFF")		
		elseif (aircraft_sel_num == nil) or (aircraft_sel_num < 1) or (aircraft_sel_num > 5) then --check for valid a/c menu selection, note nil check must come first since > or < nil is meaningless
		   ipc.writeSTR(0x3380, tab.."Invalid Entry")                                 --ipcPARAM invalid #
           ipc.writeSW(0x32FA, 4)
           return
        else                                                                    -- if input is valid a/c selection
		ipc.set("CURR_AIRCRAFT", aircraft_sel)
		ipc.set("PARAM13", "NotNil")
	    if aircraft_sel=="1" then                                               -- identify selected a/c for display
			selected_aircraft="FSX Default or Std Add-on A/C"
		 elseif aircraft_sel=="2" then
			selected_aircraft="A2A Cherokee 180"
		 elseif aircraft_sel=="3" then
			selected_aircraft="FLIGHT1 KA B200"
		 elseif aircraft_sel=="4" then
			selected_aircraft="PMDG B737 NGX"
		 elseif aircraft_sel=="5" then
			selected_aircraft="PMDG B777"
		 end	                                                                                --selected aircraft
		ipc.writeSTR(0x3380, tab..selected_aircraft.." Selected")                       -- display selected a/c choice
		ipc.writeSW(0x32FA, 4)                                                                    
	    end
	else                                                                       -- if param13 not nil
        ipc.set("PARAM13", nil) 		
		ipc.writeSTR(0x3380, tab.."Numpad Control " .. "** OFF **")                       -- since onoff must == "OFF"
		ipc.writeSW(0x32FA,4) 		                                                 --display for 4 sec NpC is off
		ipc.set("ONOFF", "OFF")
	end 	
	
	return
end

if (not(onoff == nil) and onoff == "OFF") then                                      -- Do nothing if NumPadControl is Off
	return
end


if acr == nil then                             
	ipc.writeSTR(0x3380, tab.."No Function Selected ")
	ipc.writeSW(0x32FA, 4);                                                        --Green bar msg for 4 sec
        return
end

if ipcPARAM == 11 then                                                             --swap standby freq of active radio if Com or Nav radio     
                                                                                  
	if acr == "COM_1" then 
		ipc.control(66372,1)
		ipc.sleep(10)                                                               --delay 10msec
		ipc.set("KEY_POS", 1)                                                       --reset back to first digit
	  
	  elseif acr == "COM_2" then
		ipc.control(66444, 1)
		ipc.sleep(10)
		ipc.set("KEY_POS", 1)	
	  
	  elseif acr == "NAV_1" then
		ipc.control(66448, 1)
		ipc.sleep(10)
		ipc.set("KEY_POS", 1)										
	 
	 elseif acr == "NAV_2" then
		ipc.control(66452, 1)
		ipc.sleep(10)
        ipc.set("KEY_POS", 1)

     elseif acr== "ADF_1" then
         if ipc.readLvar("AdfAdfButton")==1 then    -- check to see if A2A Cherokee 180 ADF selected and is on
            ipc.sleep(10)
            ipc.writeLvar("AdfFrqButton", 1)        -- toggle A2A Cherokee ADF freq xfer switch
            ipc.sleep(100)
			ipc.writeLvar("AdfFrqButton", 0)
         end			

	else
	  -- ipc.writeSTR(0x3380, tab.."Select Com or Nav Radio")
	   ipc.writeSTR(0x3380, tab.."Select Appropriate Radio")
    	ipc.writeSW(0x32FA, 4)
	end                                                                                           
 return
end                                                                                   --end swap

 if ipcPARAM==14 then
  ipc.set("KEY_POS", 1)                                                               --RESET back to first digit
  return
 end

if ipcPARAM == 12 then
                                                                                       --check for backspace 1 digit                                                                                                             
     if  keypos > 1 then                                                               -- do nothing if keypos is 1
         keypos=keypos-1
         ipc.set("KEY_POS", keypos)
     end
return
end                                                                                     --end BackSpace



if ipcPARAM >=0 and ipcPARAM <=10 then                                                   --only single digits or decimal point 

  if acr=="COM_1" or acr=="COM_2" or acr=="NAV_1" or acr=="NAV_2" then        --Nav freqs 108 to 117.95 MHz in 0.05MHz steps
                                                                    --Com freqs from 108 to 136.975MHz in 0.025MHz steps but only 2 decimal places used
      if ipcPARAM == 10  then                                                       -- decimal pt                                                                                                         
	    keypos=5                                                                         --point to next digit 
        ipc.set("KEY_POS", keypos)                                                       --save next digit position  
        return
      end  
      
        if keypos==7 then                                                                -- reset keypos if last digit entered since no BackSpace
           keypos=1
        end

      if acr == "COM_1"  then 
               CurrFreq =  ipc.readUW(0x311A)                                               --get freq of active radio 
	 freqloc= 0x311A                                                                         --get location of active radio freq                                                                         
  
          elseif acr=="COM_2" then
               CurrFreq =  ipc.readUW(0x311C) 
	  freqloc= 0x311C    
  
            elseif acr=="NAV_1" then
               CurrFreq =  ipc.readUW(0x311E) 
              freqloc= 0x311E  

            elseif  acr=="NAV_2" then   
                CurrFreq =  ipc.readUW(0x3120)   
	  freqloc= 0x3120                                    
         end 
   
    if keypos==1 then
          if ipcPARAM==1 then
               keypos=keypos+1                                                                 --point to position 2 next
	           ipc.set("KEY_POS", keypos)                                                      --save keypos value for next iteration
               return
           else  
                ipc.writeSTR(0x3380, tab.."Invalid Entry")                                          --ipcPARAM invalid #
                ipc.writeSW(0x32FA, 4)                                                                   
	       return
          end  
    end                                                                                        
       
            if keypos==2 then
                    freqdig3=logic.And(CurrFreq, 0x0F00)                                         -- isolate 3rd freq digit
                    if (acr=="COM_1" or acr=="COM_2")then
                       if ipcPARAM < 1 or ipcPARAM > 3  then                                     -- 2nd digit of Com freq must be 1, 2 or 3                                       
                           ipc.writeSTR(0x3380, tab.."Invalid Entry")                                 --ipcPARAM invalid #
                           ipc.writeSW(0x32FA, 4)  
                        return 
                           
                       elseif ipcPARAM == 1 and freqdig3 < 0x800 then                                -- if true, temp freqwill be to low; note freqdig3 in 100s place                       
	                         DigitSpace=logic.And(CurrFreq, 0x00FF)                                   -- create space for new freq digit and tempfreqdig at correct position                     
                             movPARAM=logic.Shl(ipcPARAM, 12)                                        -- move new digit to correct position                      
                           NewFreq = logic.Or(DigitSpace, movPARAM+0x0900)                           --add on temp 3rd freq digit = 9
                             ipc.writeUW(freqloc, NewFreq)                                          -- update radio panel                                                       
                             keypos=keypos+1
                             
                      elseif ipcPARAM == 3 and freqdig3 > 0x600 then                                  -- if true, temp freq will be to high; note freqdig3 in 100s place                       
	                         DigitSpace=logic.And(CurrFreq, 0x00FF)                                   -- create space for new freq digit and tempfreqdig at correct position                     
                             movPARAM=logic.Shl(ipcPARAM, 12)                                        -- move new digit to correct position 
                             NewFreq = logic.Or(DigitSpace, movPARAM+0x0000)                        --add in new 2nd digit and temp 3rd freq digit = 0
                             ipc.writeUW(freqloc, NewFreq)                                          -- update radio panel                                                        
                             keypos=keypos+1
                             
                      else                             
                            movPARAM=logic.Shl(ipcPARAM, 12)                                        --temp freq will be within limits                                                            
	                        DigitSpace=logic.And(CurrFreq, 0x0FFF)                                  -- create space for new freq digit                                                    
	                        NewFreq=logic.Or(DigitSpace, movPARAM)                                  -- move new digit to correct position                                                
	                        ipc.writeUW(freqloc, NewFreq)                                           -- update radio panel
                           keypos=keypos+1
                     end
                   end 
                     
                    if (acr=="NAV_1" or acr=="NAV_2")then
                       if ipcPARAM < 0 or ipcPARAM > 1   then                                         --2nd digit of Nav freq must be 0 or 1                                   
                           ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
                           ipc.writeSW(0x32FA, 4)  
                        return 
                           
                       elseif ipcPARAM == 0 and freqdig3 < 0x800 then                                   -- if true, temp freqwill be to low; note freqdig3 in 100s place                       
	                         DigitSpace=logic.And(CurrFreq, 0x00FF)                                       -- create space for new freq digit and tempfreqdig at correct position                     
                             movPARAM=logic.Shl(ipcPARAM, 12)                                           -- move new digit to correct position 
                             NewFreq = logic.Or(DigitSpace, movPARAM+0x0900)                           --add in new 2nd digit and temp 3rd freq digit = 9
                             ipc.writeUW(freqloc, NewFreq)                                                -- update radio panel                                                        
                             keypos=keypos+1
                             
                       elseif ipcPARAM == 1 and freqdig3 > 700 then                                    -- if true, temp freq will be to high; note freqdig3 in 100s place                       
	                         DigitSpace=logic.And(CurrFreq, 0x00FF)                                    -- create space for new freq digit and tempfreqdig at correct position                     
                             movPARAM=logic.Shl(ipcPARAM, 12)                                          -- move new digit to correct position 
                             NewFreq = logic.Or(DigitSpace, movPARAM+0x0000)                          --add in new 2nd digit and temp 3rd freq digit = 0
                             ipc.writeUW(freqloc, NewFreq)                                            -- update radio panel                                                        
                             keypos=keypos+1
                             
                      else                              
                            movPARAM=logic.Shl(ipcPARAM, 12)                                          --temp freq will be within limits ;move new digit to correct position
	                        DigitSpace=logic.And(CurrFreq, 0x0FFF)                                    -- create space for new freq digit                                                  
	                        NewFreq=logic.Or(DigitSpace, movPARAM)                                    -- move new digit to correct position                                                  
	                        ipc.writeUW(freqloc, NewFreq)                                             -- update radio panel
                           keypos=keypos+1
                     end
                   end                                                                                 -- point to position 3                  
        
                elseif keypos==3 then    
	                   movPARAM=logic.Shl(ipcPARAM, 8)                                                       -- move new digit to correct position
                       DigitSpace=logic.And(CurrFreq, 0xF0FF)                                                -- create space for new freq digit at correct position
	                   NewFreq=logic.Or(DigitSpace, movPARAM)                                                -- place digit                                                                                
                       if (acr=="COM_1" or acr=="COM_2") and (NewFreq < 0x1800 or NewFreq >= 0x3700) then    -- check for valid # entry
                            ipc.writeSTR(0x3380, tab.."Invalid Entry")                                            --ipcPARAM invalid #
                            ipc.writeSW(0x32FA, 4)  
                            return
                       elseif (acr=="NAV_1" or acr=="NAV_2") and (NewFreq < 0x0800 or NewFreq >= 0x1800) then
                            ipc.writeSTR(0x3380, tab.."Invalid Entry")                                                 --ipcPARAM invalid #
                            ipc.writeSW(0x32FA, 4)  
                            return
                        else
                            ipc.writeUW(freqloc, NewFreq)                                                         -- digit valid, update radio panel
                            keypos=keypos+1 
                        end
               -- no longer need the following since checked for decimal pt above                            
               --  elseif keypos==4 and ipcPARAM==10 then                                                     -- 10 indicates decimal pt
	           --   keypos=keypos+1                                                                          -- ignore input but update position
		
              elseif keypos==4 and not(ipcPARAM==10) then                                                    -- if true, this is digit for 5th position
	                 movPARAM=logic.Shl(ipcPARAM, 4)                                                         -- move new digit to correct position
                     DigitSpace=logic.And(CurrFreq, 0xFF0F)                                                  -- create space for new freq digit at correct position
	                 NewFreq=logic.Or(DigitSpace, movPARAM)                                                 -- place digit
	                 ipc.writeUW(freqloc, NewFreq)                                                          -- update radio panel
                     keypos=keypos+2                                                                         -- point to position 6 next

             elseif keypos==5 then
	                movPARAM=logic.Shl(ipcPARAM, 4)                                                        -- move new digit to correct position
                    DigitSpace=logic.And(CurrFreq, 0xFF0F)                                                  -- create space for new freq digit at correct position
	                NewFreq=logic.Or(DigitSpace, movPARAM)                                                  -- place digit
           	       ipc.writeUW(freqloc, NewFreq)                                                            -- update radio panel                                                                                       
                   keypos=keypos+1                                                                          -- point to digit 6 next
 
            elseif keypos==6  then
                   if (acr=="COM_1" or acr=="COM_2") and not(ipcPARAM == 0 or ipcPARAM ==2 or ipcPARAM == 5 or ipcPARAM == 7) then  -- because 0.025MHz channel spacing
                      ipc.writeSTR(0x3380, tab.."Invalid Entry")                                                  --ipcPARAM invalid #
                      ipc.writeSW(0x32FA, 4)  
                      return 
                  elseif   
                   ( acr=="NAV_1" or acr=="NAV_2") and not(ipcPARAM == 0 or ipcPARAM ==5 ) then             -- because 0.050MHz channel spacing
                     ipc.writeSTR(0x3380, tab.."Invalid Entry")                                                 --ipcPARAM invalid #
                      ipc.writeSW(0x32FA, 4)  
                     return 
                  else
                     DigitSpace=logic.And(CurrFreq, 0xFFF0)                                                       -- create space for new freq digit at correct position
                     NewFreq=logic.Or(DigitSpace, ipcPARAM)                                                       -- place digit
                     ipc.writeUW(freqloc, NewFreq)                                                                -- update radio panel 
                    keypos=keypos+1       
                  end                                                                                             -- update keypos in case need to BkSpc
       end                                                                                                      
     ipc.set("KEY_POS", keypos)                                                                                   --save keypos value for next iteration 
     return                                                                                                                                                     
  end                                                                                                            -- Com and Nav radios

 if  acr=="CRS_1" then                                -- this code lets the user use either the NpCsetOBS and NpCsetNAV&OBS scripts, or the NpCsetCRS and NpCsetNAV&CRS scripts
     acr="OBS_1"                                      -- setting the OBS value is the same as setting the CRS (course)
 elseif acr=="CRS_2" then                             -- actual processing code below is in term of OBS
	acr="OBS_2"
 end
 if acr == "OBS_1" or acr == "OBS_2" then
    
     if acr=="OBS_1" then
      obs_loc=0x0C4E                                                   -- FSUIPC offset location for OBS_1 for FSX default a/c and KA B200
      CourseWindow = "L:ngx_CRSwindowL" 	                         -- ngx_CRSwindowL holds 737NGX CRS Sel value for Left window (course 1)
	  PMDGpram = 70008	                                             -- for PMDG 737NGX or B777 control function, left window
	else
       obs_loc=0x0C5E                                                 -- FSUIPC offset location for OBS_2
       CourseWindow = "L:ngx_CRSwindowR" 	                         -- ngx_CRSwindowR holds 737NGX CRS Sel value for Right window (course 2)
	   PMDGpram = 70041                                               -- for PMDG 737NGX or B777 control function, right window
	end
                                                                 
     if ipcPARAM==10 then
        ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #, no decimal pt
        ipc.writeSW(0x32FA, 4)
        return
      end
      
     if keypos==4 then                                                            -- reset keypos if last digit entered since no BackSpace
        keypos=1
     end

       if keypos==1 then	     
	     if ipcPARAM >3 then
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4)  
             return 
	     else
	        ipc.set("OBSdigit1", ipcPARAM)                                                --save 100s place digit
	        keypos=keypos+1                                               --point to position 2 next                                           
          end
                                                                         
        elseif keypos==2 then
           obsdigit1 = ipc.get("OBSdigit1")
	       if obsdigit1==3 and ipcPARAM > 6 then
	        ipc.writeSTR(0x3380, tab.."Invalid Entry")                            --ipcPARAM invalid #, max OBS is 360
             ipc.writeSW(0x32FA, 4)  
	      else 
	       ipc.set("OBSdigit2", ipcPARAM)                                                --save 1s0 place digit
	       keypos=keypos+1                                               --point to position 3 next 
	      end
	        
	    elseif keypos==3 then
	       obsdigit1 = ipc.get("OBSdigit1")
	        obsdigit2=ipc.get("OBSdigit2")
	       if obsdigit1==3 and obsdigit2==6 and not (ipcPARAM == 0) then
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4) 
           else 	       
	      ipc.set("OBSdigit3", ipcPARAM)                                                --save 1s place digit
	      keypos=keypos+1                                               --point to position 4 to allow for Backspace
          end
       end   
   ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program                            

  if keypos==4 then
  obsdigit1= ipc.get("OBSdigit1")                                                   -- get saved value
  obsdigit2= ipc.get("OBSdigit2")                                                   -- get saved value
  obsdigit3= ipc.get("OBSdigit3")                                                   -- get saved value
  obs_deg = obsdigit1*100 + obsdigit2*10 + obsdigit3                                      --OBS value in degrees
  
   if aircraft_sel =="1" or aircraft_sel =="2" or aircraft_sel =="3" then    -- for FSX default, A2A Cherokee 180 and KA B200 a/c
    ipc.writeUW(obs_loc, obs_deg)                                            -- write deg info to appropriate offset  
   
   elseif aircraft_sel=="4" or aircraft_sel =="5" then                                           --for PMDG737NGX and PMDG B777  
   NewApSelObs = obs_deg                                 --  new test CRS
   CurrApSelObs=ipc.readLvar(CourseWindow) 	        -- CourseWindow = ngx_CRSwindowL or ngx_CRSwindowR which holds 737NGX CRS Sel value, see start of Course code
     ipc.sleep (10)
	 Diff_Obs=NewApSelObs-CurrApSelObs
 while Diff_Obs ~=0 do
  if Diff_Obs > 180 then 
          Diff_Obs=Diff_Obs-360
       elseif Diff_Obs < -180 then
          Diff_Obs=Diff_Obs +360
  end
 if Diff_Obs > 0 then
      while Diff_Obs >= 1 do                                               -- If new CRS higher, this loop adds in change needed 
         ipc.control(PMDGpram, 16384)                                                 -- inc by 1 deg, see start of course code for PMDGpram value
         if Diff_Obs < 10 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
		 end 
		 ipc.sleep (40)
          CurrApSelObs=ipc.readLvar(CourseWindow)
		 ipc.sleep (10)
         Diff_Obs=NewApSelObs-CurrApSelObs 
		 if Diff_Obs > 180 then 
           Diff_Obs=Diff_Obs-360
          elseif Diff_Obs < -180 then
           Diff_Obs=Diff_Obs +360
         end 
      end 
     else  
        Diff_Obs=-1*Diff_Obs                                                    -- Diff_ObsL neg, new CRS is lower, make Diff_ObsL pos for calculations
        while Diff_Obs >= 1 do                                                  -- this loop subtracts the change needed
         ipc.control(PMDGpram, 8192)                                                  --dec 1 deg,see start of course code for PMDGpram value 
         if Diff_Obs < 10 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
		 end 
	   ipc.sleep (40)
         CurrApSelObs=ipc.readLvar(CourseWindow)       -- CourseWindow = ngx_CRSwindowL or ngx_CRSwindowR which holds 737NGX CRS Sel value, see start of Course code   
		 ipc.sleep (10)
         Diff_Obs=-(NewApSelObs-CurrApSelObs)
		if Diff_Obs > 180 then 
          Diff_Obs=Diff_Obs-360
        elseif Diff_Obs < -180 then
          Diff_Obs=Diff_Obs +360
	    end
      end
    end
    CurrApSelObs=ipc.readLvar(CourseWindow) 	        -- ngx_CRSwindowL or ngx_CRSwindowR holds 737NGX CRS Sel value
     ipc.sleep (10)
	 Diff_Obs=NewApSelObs-CurrApSelObs
   end
  end
  end                                                                      -- end keypos=4     
 end                                                                   --end OBS        
   
   
  if (acr=="ADF_1") or (acr=="ADF_2") then                                                      --note ADF freqs are from 190 to 1799.5 Khz
        
        if ipcPARAM == 10  then                                                                              -- decimal pt                                                                                                        
	     keypos=6                                                                                             --point to next digit 
         ipc.set("KEY_POS", keypos)                                                                           --save next digit position  
         return
        end  
        
        
        if keypos==7 then                                                                                        -- reset keypos if last digit entered since no BackSpace
           keypos=1
        end

        if acr == "ADF_1"  then 
               CurrFreqMiddle = ipc.readUW(0x034C)                                                               --get 3 middle freq digits of active radio 
               CurrFreqOuter =  ipc.readUW(0x0356)                                                               --get 2 outside freq digits of active radio                 
               freqlocMiddle= 0x034C                                                                             --get locations of active radio freq digits                                                   
               freqlocOuter=0x0356
          
          elseif acr=="ADF_2" then
               CurrFreqMiddle = ipc.readUW(0x02D4)                                                             --get 3 middle freq digits of active radio 
               CurrFreqOuter =  ipc.readUW(0x02D6)                                                             --get 2 outside freq digits of active radio
           	 freqlocMiddle= 0x02D4                                                                           --get locations of active radio freq digits                                                  
               freqlocOuter=0x02D6   
        end
        
       digit1=logic.And(logic.Shr(CurrFreqOuter, 8),0x000F)                                                                                                                            
       digit2=logic.And(logic.Shr(CurrFreqMiddle,8),0x000F)                                                   --pass variables from previous iteration of program
       digit3=logic.And(logic.Shr(CurrFreqMiddle,4),0x000F)   
       digit4=logic.And(CurrFreqMiddle,0x000F)
     
        
        

        if keypos==1 then
                       if ipcPARAM==0 then 
                          if digit2*100 + digit3*10 < 190 then                                            -- min freq is 190KHz
                             DigitSpaceMiddle=logic.And(CurrFreqMiddle, 0xF0FF)                           --create space for new digit
                             NewFreqMiddle=logic.Or(DigitSpacMiddle, 0x0900)                              --make temp freq digit 9
                             ipc.writeUW(freqlocMiddle, NewFreqMiddle)                                   -- write temp middle freq digit (note have to write middle freq when updating outer freq)
	                         ipc.writeUW(freqlocOuter, NewFreqOuter)                                     -- update radio panel 
                             keypos=keypos+1                                                              --point to position 2 next
                             ipc.set("KEY_POS", keypos)                                                  --save next position info for next iteration
                             
                           else 
                              NewFreqOuter=logic.And(CurrFreqOuter,0xF0FF)
                              ipc.writeUW(freqlocMiddle, CurrFreqMiddle)                                   --apparently need to write middle freq when updating outer freq
	                          ipc.writeUW(freqlocOuter, NewFreqOuter)                                         -- update radio panel 
                              keypos=keypos+1                                                           --point to position 2 next
                              ipc.set("KEY_POS", keypos) 
                            end
                            
                        elseif ipcPARAM ==1 then
                               if digit2 > 7 then                                                     -- max freq is 1799.5KHz
                                  NewFreqMiddle=logic.And(CurrFreqMiddle, 0xF0FF)                     -- temp freq digit = 0
                          	      DigitSpaceOuter=logic.And(CurrFreqOuter, 0xF0FF)                    -- create space for new freq digit at correct position
	                              NewFreqOuter=logic.Or(DigitSpaceOuter,0x0100) 
                                  ipc.writeUW(freqlocMiddle, NewFreqMiddle)                          --apparently need to write middle freq when updating outer freq
	                              ipc.writeUW(freqlocOuter, NewFreqOuter)                             -- update radio panel 
                                  keypos=keypos+1                                                   --point to position 2 next
                                  ipc.set("KEY_POS", keypos) 
                             
                                else 
                         	      DigitSpaceOuter=logic.And(CurrFreqOuter, 0xF0FF)                  -- create space for new freq digit at correct position
	                              NewFreqOuter=logic.Or(DigitSpaceOuter,0x0100)
                                  ipc.writeUW(freqlocMiddle, CurrFreqMiddle)                        --apparently need to write middle freq when updating outer freq
	                              ipc.writeUW(freqlocOuter, NewFreqOuter)                           -- update radio panel 
                                  keypos=keypos+1                                                   --point to position 2 next
                                  ipc.set("KEY_POS", keypos) 
                                end            
                 
                        else                                                                                                                                         
	                       ipc.writeSTR(0x3380, tab.."Invalid Entry")                                    -- invalid if first digit not 0 or 1   
                           ipc.writeSW(0x32FA, 4)  
                       return
                       end
     

          elseif keypos==2 then
                      if (digit1==1 and ipcPARAM > 7) or (digit1==0 and ipcPARAM==0) then	    
                        ipc.writeSTR(0x3380, tab.."Invalid Entry")                                       --ipcPARAM invalid #
                        ipc.writeSW(0x32FA, 4)  
                        return                                       
                      end    
                     if digit1==0 and ipcPARAM==1 then                                    --if true, next digit(digit 3) must be 9
                             DigitSpaceMiddle=logic.And(CurrFreqMiddle, 0xF00F)           -- need space for ipcPARAM and temp freq digit
                             NewFreqMiddle=logic.Or(DigitSpaceMiddle, 0x0190)                             
                             ipc.writeUW(freqlocMiddle, NewFreqMiddle)                    -- only need to write middle freq when updating outer freq       
                             keypos=keypos+1                                              --point to position 2 next
                             ipc.set("KEY_POS", keypos) 
                    else
                             movPARAM=logic.Shl(ipcPARAM, 8)                              -- move new digit to correct position
                             DigitSpaceMiddle=logic.And(CurrFreqMiddle, 0xF0FF)
                             NewFreqMiddle=logic.Or(DigitSpaceMiddle, movPARAM)                             
                             ipc.writeUW(freqlocMiddle, NewFreqMiddle)                    --update radio panel 
                             keypos=keypos+1                                              --point to position 2 next
                             ipc.set("KEY_POS", keypos) 
                     end 
                                                                                        
                
              elseif keypos==3 then
                    if  digit1==0 and  digit2==1 and not(ipcPARAM==9) then
                             ipc.writeSTR(0x3380, tab.."Invalid Entry")                        --ipcPARAM invalid #
                             ipc.writeSW(0x32FA, 4)  
                             return
                   
                   else           
	                   movPARAM=logic.Shl(ipcPARAM,4)                                    -- move new digit to correct position
                       DigitSpace=logic.And(CurrFreqMiddle, 0xFF0F)                      -- create space for new freq digit at correct position
	                   NewFreqMiddle=logic.Or(DigitSpace, movPARAM)                      -- place digit
	                   ipc.writeUW(freqlocMiddle, NewFreqMiddle)                         -- update radio panel
                       keypos=keypos+1                                                   --point to  position 4 next
                    end

             elseif keypos==4 then
	           DigitSpace=logic.And(CurrFreqMiddle, 0xFFF0)                             -- create space for new freq digit at correct position 
	           NewFreqMiddle=logic.Or(DigitSpace, ipcPARAM)                             -- place digit
	           ipc.writeUW(freqlocMiddle, NewFreqMiddle)                                -- update radio panel
                keypos=keypos+1                                                         --point to position 5 next
                  
            
         -- no longer need the following since checked for decimal pt above
         --        elseif keypos==5 and ipcPARAM==10 then                             -- ignore decimal pt input but update position
         --                keypos=keypos+1                                            --point to position 6

                                                   
    	    elseif keypos==5 and not(ipcPARAM==10)  then                                                -- if true, this is digit for last position   
                           if (digit1*1000+ digit2*100+ digit3*10+ digit4+ipcPARAM/10 >1799.5) then     --max freq is 1750KHz                                                     
                           ipc.writeSTR(0x3380, tab.."Invalid Entry")                                        --ipcPARAM invalid #
                           ipc.writeSW(0x32FA, 4)  
                           return
                        
                          else
	                        DigitSpace=logic.And(CurrFreqOuter, 0xFFF0)                    -- create space for new freq digit at correct position
	                        NewFreqOuter=logic.Or(DigitSpace, ipcPARAM)                    -- place digit
                             ipc.writeUW(freqlocMiddle, CurrFreqMiddle)                    --apparently need to write middle freq when updating outer freq
	                        ipc.writeUW(freqlocOuter, NewFreqOuter)                        -- update radio panel 
                             keypos=keypos+2                                              -- update keypos in case need to BkSpc   
                         end
  
               elseif keypos==6 then
                   if (digit1*1000+ digit2*100+ digit3*10+ digit4+ipcPARAM/10 >1799.5) then     --max freq is 1799.5KHz                                                                          
                          ipc.writeSTR(0x3380, tab.."Invalid Entry")                                 --ipcPARAM invalid #
                          ipc.writeSW(0x32FA, 4)  
                        return
                 else
                          DigitSpace=logic.And(CurrFreqOuter, 0xFFF0)                            -- create space for new freq digit at correct position
	            NewFreqOuter=logic.Or(DigitSpace, ipcPARAM)                                      -- place digit
                           ipc.writeUW(freqlocMiddle, CurrFreqMiddle)                            --apparently need to write middle freq when updating outer freq                 
	            ipc.writeUW(freqlocOuter, NewFreqOuter)                                          -- update radio panel
                          keypos=keypos+1                                                       -- update keypos in case need to BkSpc             
                  end                                                                                                --save keypos value for next iteration	   
       end
    
       ipc.set("KEY_POS", keypos)
       return
 
  end                                                                                            -- end ADF 
                                                                                                  -- end of ipcPARAM  between 0 and 10 for Com, Nav, ADF radios  

if acr== "AP_ALT" then

     if ipcPARAM==10 then
        ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #, no decimal pt
        ipc.writeSW(0x32FA, 4)
        return
      end
     if keypos==6 then                                                               -- reset keypos if last digit entered since no BackSpace
           keypos=1
     end

       if keypos==1 then	     
	      ipc.set("ALT_1", ipcPARAM)                                                --save 10,000 place digit
	      keypos=keypos+1                                               --point to position 2 next                                           
                                                                         
        elseif keypos==2 then
	      ipc.set("ALT_2", ipcPARAM)                                                --save 1000 place digit
	      keypos=keypos+1                                               --point to position 3 next 
	        
	    elseif keypos==3 then
	      ipc.set("ALT_3", ipcPARAM)                                                --save 100 place digit
	      keypos=keypos+1                                               --point to position 4 next 

       elseif keypos==4 then
             if not( ipcPARAM==0)then
               ipc.writeSTR(0x3380, tab.."Invalid Entry 4, Need 0")                                      --ipcPARAM invalid #
               ipc.writeSW(0x32FA, 4)  
               return                                                  --10s place digit must be 0
	         else keypos=keypos+1                                               --point to position 5 next 
            end
             
       elseif keypos==5 then      
             if not( ipcPARAM==0)then                                 --1s place digit must be 0
               ipc.writeSTR(0x3380, tab.."Invalid Entry 5, need 0")                                     
               ipc.writeSW(0x32FA, 4)  
               return                                                 
	         else keypos=keypos+1                                      --point to position 6 incse BackSpace 
           end
       end
   ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program                          
  

  if keypos==6 then
   alt1= ipc.get("ALT_1")                                                   -- get saved value
   alt2= ipc.get("ALT_2")                                                   -- get saved value
   alt3= ipc.get("ALT_3")                                                   -- get saved value
   alt_ft = alt1*10000 + alt2*1000 +alt3*100                             -- alt in feet; tens and unit place are assumed to be 0

 if aircraft_sel =="1" then                                                      -- aircraft_sel =="1" for default FSX a/c
  alt_value = (alt_ft*65536)/3.28084                                     --FSUIPC offset value needed is altitude in meters times 65536
    ipc.writeUD(0x07D4, alt_value)                                           -- write altitude to offset  
 
  elseif aircraft_sel =="3" then                                         -- aircraft_sel =="3" for Flight1 KA B200
    NewApSelAlt = alt_ft
	 CurrApSelAlt=ipc.readLvar("L:F1G1000APALT") 	 -- F1G1000APALT holds B200 Alt Sel value
     ipc.sleep (5)
	 Diff_Alt=NewApSelAlt-CurrApSelAlt                                         -- If new alt higher, Diff_Alt reflects how many 1000s of ft and 100s of ft of change needed
   while Diff_Alt ~= 0 do    
	if Diff_Alt > 0 then                                                      -- this loop adds in the "thousands" of ft
        while Diff_Alt >= 1000 do
          ipc.control(65823, 78)                                             -- inc by 1000
          ipc.control(65823)
          ipc.sleep (45)
          CurrApSelAlt=ipc.readLvar("L:F1G1000APALT")
		  ipc.sleep (10)
          Diff_Alt=NewApSelAlt-CurrApSelAlt
		end
        while Diff_Alt >= 100 do                                               -- If new alt higher, this loop adds in 100s of ft of change needed 
          ipc.control(65823,71)                                                 -- inc by 100
          ipc.control(65823)
          ipc.sleep (100)
          CurrApSelAlt=ipc.readLvar("L:F1G1000APALT")
		  ipc.sleep (10)
          Diff_Alt=NewApSelAlt-CurrApSelAlt
        end  
     else  
        Diff_Alt=-1*Diff_Alt                                                    -- Diff_Alt neg, new altitude is lower, make Diff_Alt pos for calculations
        while Diff_Alt >= 1000 do                                               -- this loop subtracts the "thousands" of ft                                             
          ipc.control(65823, 77)                                                -- dec by 1000
          ipc.control(65823)
          ipc.sleep (45)
          CurrApSelAlt=ipc.readLvar("L:F1G1000APALT")
		  ipc.sleep (10)
          Diff_Alt=-(NewApSelAlt-CurrApSelAlt)
        end
       while Diff_Alt >= 100 do                                                  -- this loop subtracts the 100s of ft needed
         ipc.control(65823, 70)                                                  --dec 100 ft 
         ipc.control(65823)
         ipc.sleep (100)
         CurrApSelAlt=ipc.readLvar("L:F1G1000APALT")
		 ipc.sleep (10)
         Diff_Alt=-(NewApSelAlt-CurrApSelAlt)                                
       end
     end    
     CurrApSelAlt=ipc.readLvar("L:F1G1000APALT") 	                     -- F1G1000APALT holds B200 Alt Sel value
     ipc.sleep (5)
	 Diff_Alt=NewApSelAlt-CurrApSelAlt                                       --  final check
    end                                                                            -- while Diff_Alt not = 0
  elseif aircraft_sel=="4" or aircraft_sel == "5" then                                                       -- aircraft_sel =="4" for	PMDG B737NGX, "5" for PMDG B777  
        NewApSelAlt=alt_ft
		CurrApSelAlt=ipc.readLvar("L:ngx_ALTwindow") 	                           -- ngx_ALTwindow holds 737NGX Alt Sel value
       ipc.sleep (10)
	   Diff_Alt=NewApSelAlt-CurrApSelAlt                                         -- If new alt higher, Diff_Alt reflects how many 1000s of ft and 100s of ft of change needed
     while Diff_Alt ~= 0 do 
	  if Diff_Alt > 0 then                                                         
	   while Diff_Alt > 98 do                                               -- If new alt higher, this loop adds in 100s of ft of change needed, 98 allows for rounding error 
	       if aircraft_sel=="4" then
            ipc.control(70032, 16384)		                                        -- inc by 100, NGX737
		   else
		    ipc.control(71882, 256)                                                -- inc by 100, B777
		   end
		  if Diff_Alt < 1000 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
		  end
          ipc.sleep (40)
           CurrApSelAlt=ipc.readLvar("L:ngx_ALTwindow")
		  ipc.sleep (10)
          Diff_Alt=NewApSelAlt-CurrApSelAlt
        end  
      else  
        Diff_Alt=-1*Diff_Alt                                                    -- Diff_Alt neg, new altitude is lower, make Diff_Alt pos for calculations
        while Diff_Alt > 98 do                                                  -- this loop subtracts the 100s of ft needed, 98 allows for rounding error
		  if aircraft_sel =="4" then
           ipc.control(70032, 8192)  		                                       --dec 100 ft, NGX737 
		  else
		   ipc.control(71882, 128)                                                --dec 100 ft, B777
		 end
         if Diff_Alt < 1000 then                                                   -- slow down when less than 10 steps left
		  ipc.sleep (60)
		 end
		 ipc.sleep (40)
         CurrApSelAlt=ipc.readLvar("L:ngx_ALTwindow")
		 ipc.sleep (10)
         Diff_Alt=-(NewApSelAlt-CurrApSelAlt)
	   end
      end 	                                                            --if Diff_Alt >0
        CurrApSelAlt=ipc.readLvar("L:ngx_ALTwindow")   --final check on new alt value
	    ipc.sleep (10)
        Diff_Alt=NewApSelAlt-CurrApSelAlt
   end                                                                   -- while Diff_Alt not 0
  end                                                                  --elseif from aircraft_sel == "1", etc 
 end                                                                       --keypos==6
 return
end                                                                         --arc=AP_Alt                                                                   


if acr== "AP_HDG" then

     if ipcPARAM==10 then
        ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #, no decimal pt
        ipc.writeSW(0x32FA, 4)
        return
      end
      
     if keypos==4 then                                                            -- reset keypos if last digit entered since no BackSpace
        keypos=1
     end

       if keypos==1 then	     
	     if ipcPARAM >3 then
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4)  
             return 
	     else
	        ipc.set("HDG_1", ipcPARAM)                                                --save 100s place digit
	        keypos=keypos+1                                               --point to position 2 next                                           
          end
                                                                         
        elseif keypos==2 then
           hdg1 = ipc.get("HDG_1")
	       if hdg1==3 and ipcPARAM > 6 then
	        ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4)  
	      else 
	       ipc.set("HDG_2", ipcPARAM)                                                --save 1s0 place digit
	       keypos=keypos+1                                               --point to position 3 next 
	      end
	        
	    elseif keypos==3 then
	        hdg1 = ipc.get("HDG_1")
	        hdg2=ipc.get("HDG_2")
	       if hdg1==3 and hdg2==6 and not (ipcPARAM == 0) then
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4) 
           else 	       
	      ipc.set("HDG_3", ipcPARAM)                                                --save 1s place digit
	      keypos=keypos+1                                               --point to position 4 to allow for Backspace
          end
       end   
   ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program                            

  if keypos==4 then
  hdg1= ipc.get("HDG_1")                                                   -- get saved value
  hdg2= ipc.get("HDG_2")                                                   -- get saved value
  hdg3= ipc.get("HDG_3")                                                   -- get saved value
  hdg_deg = hdg1*100 + hdg2*10 + hdg3                                      -- heading in degrees
  
    if aircraft_sel =="1" or aircraft_sel == "2" or aircraft_sel == "3" then   -- Hdg process same for FSX default, A2A Cherokee 180 and KA B200 a/c
       hdg_value = (hdg_deg*65536)/360                                     --FSUIPC offset value needed
       ipc.writeUD(0x07CC, hdg_value)                                        -- write deg info to offset 
  
    elseif  aircraft_sel == "4" or aircraft_sel=="5" then                    --   for PMDG 737NGX and B777
     NewApSelHdg = hdg_deg                                
	 CurrApSelHdg=ipc.readLvar("L:ngx_HDGwindow") 	 -- ngx_HDGwindow holds 737NGX HDG Sel value
     ipc.sleep (10)
	 Diff_Hdg=NewApSelHdg-CurrApSelHdg
    while Diff_Hdg ~=0 do     
	 if Diff_Hdg > 180 then 
          Diff_Hdg=Diff_Hdg-360
       elseif Diff_Hdg < -180 then
          Diff_Hdg=Diff_Hdg +360
       end
     if Diff_Hdg > 0 then
      while Diff_Hdg >= 1 do                                               -- If new HDG higher, this loop adds in change needed 
	     if aircraft_sel == "4" then
         ipc.control(70022, 16384)                                                 -- 737NGX, inc by 1 deg 
		 else
		 ipc.control(71812, 256)                                                  -- B777, inc by 1 deg 
         end		 
        if Diff_Hdg < 10 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
		  end
		ipc.sleep (40)
          CurrApSelHdg=ipc.readLvar("L:ngx_HDGwindow")
		 ipc.sleep (10)
         Diff_Hdg=NewApSelHdg-CurrApSelHdg 
		 if Diff_Hdg > 180 then 
          Diff_Hdg=Diff_Hdg-360
         elseif Diff_Hdg < -180 then
          Diff_Hdg=Diff_Hdg +360
         end 
      end 
     else  
        Diff_Hdg=-1*Diff_Hdg                                                    -- Diff_Hdg neg, new heading is lower, make Diff_Hdg pos for calculations
        while Diff_Hdg >= 1 do                                                  -- this loop subtracts the change needed
         if aircraft_sel == "4" then
          ipc.control(70022, 8192)                                                 -- 737NGX, dec by 1 deg 
		 else
		  ipc.control(71812, 128)                                                  -- B777, dec by 1 deg 
         end
         if Diff_Hdg < 10 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
		  end
		ipc.sleep (40)
         CurrApSelHdg=ipc.readLvar("L:ngx_HDGwindow")
		 ipc.sleep (10)
         Diff_Hdg=-(NewApSelHdg-CurrApSelHdg)
		 if Diff_Hdg > 180 then 
          Diff_Hdg=Diff_Hdg-360
         elseif Diff_Hdg < -180 then
          Diff_Hdg=Diff_Hdg +360
		 end
		 
       end     
    end
     CurrApSelHdg=ipc.readLvar("L:ngx_HDGwindow") 	 -- ngx_HDGwindow holds 737NGX HDG Sel value
     ipc.sleep (10)
	 Diff_Hdg=NewApSelHdg-CurrApSelHdg
 end                                                                       --while Diff_Hdg not = 0
  end                                                                     -- if aircraft_sel = block
 end                                                                      -- end keypos=4     
end                                                                     -- end acr=AP_HDG    


if acr== "AP_KTS" then                                               -- Knots format is ###
   
     if ipcPARAM==10 then
	    ipc.set("KEY_POS", 1)                                           --save keypos value for next iteration of program   
        ipc.writeSTR(0x3380, tab.."Invalid Entry, No Decimal Pt, Enter Value in Knots")                                      --ipcPARAM invalid #, no decimal pt, reset keypos
        ipc.writeSW(0x32FA, 4)
        return
      end
      
     if keypos==4 then                                                            -- reset keypos if last digit entered since no BackSpace
        keypos=1
     end

       if keypos==1 then	     
	        ipc.set("KTS_1", ipcPARAM)                                                --save 100s place digit
	        keypos=keypos+1                                               --point to position 2 next                                           

                                                                         
        elseif keypos==2 then
	       ipc.set("KTS_2", ipcPARAM)                                                --save 10s place digit
	       keypos=keypos+1                                               --point to position 3 next 

	        
	    elseif keypos==3 then
	        kts1 = ipc.get("KTS_1")
	        kts2 = ipc.get("KTS_2")
	       if kts1==9 and kts2==9 and not (ipcPARAM == 0) then                         -- Max knots display is 990
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4) 
           else 	       
	      ipc.set("KTS_3", ipcPARAM)                                                --save 1s place digit
	      keypos=keypos+1                                               --point to position 4 to allow for Backspace
          end
       end   
   ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program                            

  if keypos==4 then
  kts1= ipc.get("KTS_1")                                                   -- get saved value
  kts2=ipc.get("KTS_2")                                                   -- get saved value
  kts3= ipc.get("KTS_3")                                                   -- get saved value
  knots = kts1*100 + kts2*10 + kts3                                      -- airspeed in knots
  if knots < 1 then
  ipc.writeSTR(0x3380, tab.."Minimum Knots Entry = 0")                --min Knots value is 0 for default a/c
        ipc.writeSW(0x32FA, 4)
  return
  end
  if aircraft_sel=="1" then                                 -- for some default FSX a/c, note no airspeed entry possible for KA B200
   ipc.writeUW(0x07E2, knots)                                        -- write airspeed info to offset                                                                                                      

 elseif aircraft_sel=="4" or aircraft_sel=="5" then                                              -- for PMDG 737NGX and B777  
     NewApSelSpd = knots
	 if NewApSelSpd <100 then                                           -- ie, is current airspeed in knots
	    ipc.writeSTR(0x3380, tab.."Minimum Knots Entry = 100")                --min Knots value is 100
        ipc.writeSW(0x32FA, 4)
		return
	 end
	 CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow") 	                 -- ngx_SPDwindow holds 737NGX Speed Sel value
     ipc.sleep (10)
	 
	  if CurrApSelSpd <1 then                                           -- ie, is a/c AP in Mach mode
	   ipc.writeSTR(0x3380, tab.."AP is in Mach Mode")                --min Knots value is 100
        ipc.writeSW(0x32FA, 4)
	   return
	end
	 
	 Diff_Spd=NewApSelSpd-CurrApSelSpd                                         -- If new Sp higher, Diff_Spd reflects change needed
    while Diff_Spd ~=0 do
	if Diff_Spd > 0 then                                                     
        while Diff_Spd >= 1 do                                               -- If new spd higher, this loop adds change needed 
		if aircraft_sel=="4" then
         ipc.control(70016, 16384)                                                 -- inc by 1 for 737NGX
		 else
		 ipc.control(69842,256)                                                     -- inc by 1 for B777
		 end
        if Diff_Spd < 10 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
		  end
		ipc.sleep (30)
           CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow")
		  ipc.sleep (10)
          Diff_Spd=NewApSelSpd-CurrApSelSpd 
        end  
     else  
        Diff_Spd=-1*Diff_Spd                                                    -- Diff_Spd neg, new altitude is lower, make Diff_Alt pos for calculations
        while Diff_Spd >= 1 do                                                  -- this loop subtracts change needed
		 if aircraft_sel=="4" then
         ipc.control(70016, 8192)                                                  --dec by 1 for NGX737  
		 else
		 ipc.control(69842, 128)                                                   --dec by 1 for B777
		 end
       if Diff_Spd < 10 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
	   end
	  ipc.sleep (30)
         CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow")
		 ipc.sleep (10)
         Diff_Spd=-(NewApSelSpd-CurrApSelSpd)
	  end
	 end
     CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow") 	                 -- ngx_SPDwindow holds 737NGX Speed Sel value
     ipc.sleep (10)
     Diff_Spd=NewApSelSpd-CurrApSelSpd 
  end                                                                    --do while Diff_Spd not = 0
   end                                                                      -- aircraft_sel block
  end                                                                      -- end keypos=4 
 end                                                                     -- end acr=AP_KTS  

 
if acr== "AP_MACH" then                                                  --eventual MACHvformat is #.##
  
    if keypos==1 then	     
	     if ipcPARAM >1 then
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #, max MACH is 1.64
             ipc.writeSW(0x32FA, 4)  
            return 
	     else
	        ipc.set("MACH_1", ipcPARAM)                                       --save units place digit
	        keypos=keypos+1                                               --point to position 2 next                                           
         end
                                                                         
    elseif keypos==2 then
         if not(ipcPARAM==10)then
	        ipc.writeSTR(0x3380, tab.."Re-enter Value With Decimal Point")                   --must be decimal pt
             ipc.writeSW(0x32FA, 4)  
	     else 
	       keypos=keypos+1                                               --point to position 3 next 
	     end
	        
	elseif keypos==3 then
		 mach1= ipc.get("MACH_1")                                                   -- get saved value
	     if (ipcPARAM==10) or (mach1==1 and ipcPARAM > 6) then                                           --note have already checked that ipcPARAM values are between 0 & 10 
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4) 
         else 	       
			ipc.set("MACH_2", ipcPARAM)                                       --save tenth digit
	        keypos=keypos+1                                                 -- point to position 4 next  --point to position 5 to allow for Backspace
         end
       
    elseif keypos==4 then
		 mach1= ipc.get("MACH_1")                                                   -- get saved value
		 mach2= ipc.get("MACH_2")                                                   -- get saved value
	     if (ipcPARAM==10) or (mach1==1 and mach2==6 and ipcPARAM > 4)then
	         ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
             ipc.writeSW(0x32FA, 4) 
         else 	       
	       ipc.set("MACH_3", ipcPARAM)                                       --save hundredth digit
	      keypos=keypos+1                                                  --point to position 5 to allow for Backspace (or point to next digit for B777)	  
         end 
           
      if keypos==5 and aircraft_sel~="5" then                            -- if true, process mach for all a/c except B777                       
         keypos=1                                                            --reset key position
         mach1= ipc.get("MACH_1")                                                   -- get saved value
         mach2=ipc.get("MACH_2")                                                   -- get saved value
         mach3= ipc.get("MACH_3")                                                   -- get saved value
         mach = mach1 + mach2/10 + mach3/100                                      -- airspeed in Mach #
 
        if aircraft_sel=="1" then                                     -- -- for some default FSX a/c, note no airspeed entry possible for KA B200
          mach_value = (mach*65536)                                     --FSUIPC offset value needed
          ipc.writeUD(0x07E8, mach_value)                                        -- write airspeed info to offset   
        end
        if aircraft_sel=="4" then                                              -- for PMDG 737NGX  
           NewApSelSpd = mach
	       if NewApSelSpd < 0.60 or NewApSelSpd > 0.82 then
	          ipc.writeSTR(0x3380, tab.."Min Mach 0.60,  Max Mach 0.82")                                      --min mach is 0.60
              ipc.writeSW(0x32FA, 4)  
              return
            end	
           CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow") 	                           -- ngx_SPDwindow holds 737NGX or B777 Speed Sel value
           ipc.sleep (10) 

           if CurrApSelSpd > 99 then                                           -- ie, is a/c AP in Knots mode
	         ipc.writeSTR(0x3380, tab.."AP is in Knots Mode")                        --min Knots value is 100
             ipc.writeSW(0x32FA, 4)
		     return
	        end
	 
	       Diff_Spd=NewApSelSpd-CurrApSelSpd                                         -- If new Sp higher, Diff_Spd reflects change needed
           while Diff_Spd ~= 0 do
              if Diff_Spd > 0 then                                                     
                while Diff_Spd >= 0.008 do                                               -- If new spd higher, this loop adds change needed, 0.008 test (vice 0.01) allows for rounding 
                  ipc.control(70016, 16384)                                                 -- inc by .01
                  if Diff_Spd < 0.10 then                                                     -- slow down when less than 10 steps left
		            ipc.sleep (60)
		          end
		          ipc.sleep (70)
                  CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow")
		          ipc.sleep (10)
                  Diff_Spd=NewApSelSpd-CurrApSelSpd
                end  
              else  
               Diff_Spd=-1*Diff_Spd                                                    -- Diff_Spd neg, new altitude is lower, make Diff_Alt pos for calculations
               while Diff_Spd >= 0.008 do                                                  -- this loop subtracts change needed
                 ipc.control(70016, 8192)                                                  --dec by .01  
                 if Diff_Spd < 0.10 then                                                     -- slow down when less than 10 steps left
		           ipc.sleep (60)
                 end
		        ipc.sleep (70)
                CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow")
		        ipc.sleep (10)
                Diff_Spd=-(NewApSelSpd-CurrApSelSpd) 
	           end
	         end                                                                    --Diff_Spd
              CurrApSelSpd=ipc.readLvar("L:ngx_SPDwindow") 	                 -- ngx_SPDwindow holds 737NGX Speed Sel value
             ipc.sleep (10)
             Diff_Spd=NewApSelSpd-CurrApSelSpd 
          end                                                                    --do while Diff_Spd not = 0
        end                                                   --aircraft = 3
     end                                                  -- if aircraft_sel not = 5
	 
                                                                 -- while Diff_Spd not = 0
  
   end                                                                      --elseif keypos 
   ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of key postion loop
                                                                           
 end                                                                     -- end acr=AP_MACH  
 end                                                                 --ipcPARAM >=0 and ipcPARAM <=10 

if (ipcPARAM >=0 and ipcPARAM <=10) or ipcPARAM==15 or ipcPARAM==16 then
 if acr== "AP_VS" then
     if aircraft_sel =="4" or aircraft_sel=="5" then 
	   vs_active=ipc.readLvar("L:ngx_MCP_VS")                               --2nd check to see if VS window is "alive", also checked in NpCsetVS
	   ipc.sleep(10)                                                            -- this 2nd check catches VS window going inactive while numbers being typed in.
	   if vs_active~=1 then
	    ipc.writeSTR(0x3380, tab.."VS Mode Not Active")                                   
        ipc.writeSW(0x32FA, 4)
		return
	   end
	 end
	 if ipcPARAM==10 then
        ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #, no decimal pt
        ipc.writeSW(0x32FA, 4)
        return
      end
     if keypos==6 then                                                               -- reset keypos if last digit entered since no BackSpace
        keypos=1
     end

     if keypos==1 then	                                                     --15 for VS up (e.g.,Num+), 16 for VS down e.g.,(Num-) signs   
	  if not(ipcPARAM == 15 or ipcPARAM == 16) then
	    ipc.writeSTR(0x3380, tab.."Invalid Entry, Need Up or Down")                          --ipcPARAM invalid #, need Up or Down key
        ipc.writeSW(0x32FA, 4)
        return
	  elseif ipcPARAM == 15 then	     
	    sign=1
	    ipc.set("SIGN",sign)
	    keypos=keypos+1
	    ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program   
	    return
	  else
	    sign=-1
	     ipc.set("SIGN",sign)
	     keypos=keypos+1
	     ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program   
	     return	  	 
	  end
	 end  	                                               
                                                                         
      if keypos==2 then   
	      ipc.set("VS_2", ipcPARAM)                                      --save 1000 place digit
	      keypos=keypos+1                                               --point to position 3 next 
	        
	    elseif keypos==3 then	   
	      ipc.set("VS_3", ipcPARAM)                                     -- save 100s digit
	      keypos=keypos+1                                               --point to position 4 next 

       elseif keypos==4 then
	         vs2= ipc.get("VS_2") 
             if not(( ipcPARAM==0)or (ipcPARAM==5 and aircraft_sel =="4" and vs2 ==0)) then  -- can have 50 ft resolution if |VS| value <= 1000ft, 100 foot resolution otherwise 
               ipc.writeSTR(0x3380, tab.."Digit 3 Invalid")                   -- 10s digit must be 0, ipcPARAM invalid #
               ipc.writeSW(0x32FA, 4)  
               return                                                  --10s place digit must be 0
			else	 
                ipc.set("VS_4", ipcPARAM)                                     -- save 10s digit, can be 0 or 5 for 737NGX,0 for all else
			    keypos=keypos+1                                      --point to position 5 next 
			end
             
       elseif keypos==5 then      
             if not( ipcPARAM==0)then                                 --1s place digit must be 0
               ipc.writeSTR(0x3380, tab.."Invalid Entry 5, Need 0")                                     
               ipc.writeSW(0x32FA, 4)  
               return                                                 
	         else keypos=keypos+1                                      --point to position 6 incase have BackSpace 
           end      
       end
  ipc.set("KEY_POS", keypos)                                           --save keypos value for next iteration of program                          

  if keypos==6 then   
   vs2= ipc.get("VS_2")                                                   -- get saved value
   vs3= ipc.get("VS_3")                                                   -- get saved value
   vs4= ipc.get("VS_4")                                                   -- get saved value
  sign=ipc.get("SIGN")                                                   -- get saved value
   vs_ftpermin = sign*(vs2*1000 + vs3*100 + vs4*10 )                     --Vert Speed in ft/min; unit place assumed to be 0
   
   if aircraft_sel =="1" or aircraft_sel == "3" then                     -- VS process same for FSX default and KA B200 a/c   
      ipc.writeSW(0x07F2,vs_ftpermin)
	  
   elseif  aircraft_sel =="4" or aircraft_sel=="5" then                                          --for PMDG 737NGX and B777
   NewApSelVspd = vs_ftpermin                                            --  new VS
	 CurrApSelVspd=ipc.readLvar("L:ngx_VSwindow") 	 -- ngx_VSwindow holds 737NGX VS Sel value
     ipc.sleep (10)
	 Diff_Vspd=NewApSelVspd-CurrApSelVspd                                         -- If new VS higher, Diff_Vspd reflects  change needed
    while Diff_Vspd ~= 0 do   
   if Diff_Vspd >= 0 then                                                      
        while Diff_Vspd >= 50 do                                               -- If new VS higher, this loop adds in change needed 
		 if aircraft_sel=="4" then
          ipc.control(70033, 8192)                                                 -- inc by 50, 737NGX
		 else
		  ipc.control(69854, 128)                                                 -- inc by 50, B777
		 end
          if Diff_Vspd < 500 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
          end
		 ipc.sleep (50)
           CurrApSelVspd=ipc.readLvar("L:ngx_VSwindow")
		  ipc.sleep (10)
          Diff_Vspd=NewApSelVspd-CurrApSelVspd
      	end	
     else  
        Diff_Vspd=-1*Diff_Vspd                                                    -- Diff_Vspd neg, new altitude is lower, make Diff_Vspd pos for calculations
       while Diff_Vspd >= 50 do                                                  -- this loop subtracts the change needed
	    if aircraft_sel=="4" then
         ipc.control(70033, 16384)                                                  --dec 50 ft for 737NGX
		else
          ipc.control(69854, 256)                                                    --dec 50 ft for B777
        end		  
        if Diff_Vspd < 500 then                                                     -- slow down when less than 10 steps left
		  ipc.sleep (60)
         end
		ipc.sleep (50)
         CurrApSelVspd=ipc.readLvar("L:ngx_VSwindow")
		 ipc.sleep (10)
         Diff_Vspd=-(NewApSelVspd-CurrApSelVspd)
		end
	 end
     ipc.sleep (60)
	 CurrApSelVspd=ipc.readLvar("L:ngx_VSwindow") 	 -- ngx_VSwindow holds 737NGX VS Sel value
     ipc.sleep (10)
	 Diff_Vspd=NewApSelVspd-CurrApSelVspd 
   end   
  end
 end
 return   
 end
end                                                                       --ipcPARAM from 0 to 10 or 15 or 16


  if acr=="SQK"  then  
     if ipcPARAM < 0 or ipcPARAM > 7 then                                                --no digits >7 for transponder           
              ipc.writeSTR(0x3380, tab.."Invalid Entry")                                      --ipcPARAM invalid #
              ipc.writeSW(0x32FA, 4)  
              return 
     end
                                      
         CurrCode =  ipc.readUW(0x0354)                                                  --get code of active radio 
         codeloc= 0x0354                                                                 --get location of active radio code                                                                           
         if keypos==5 then                                                               -- reset keypos if last digit entered since no BackSpace
           keypos=1
         end

       if keypos==1 then
	       movPARAM=logic.Shl(ipcPARAM,12)                                               -- move new digit to correct position (unlike Com & Nav, 1st digit not always the same)
	       DigitSpace=logic.And(CurrCode , 0x0FFF)                                       -- create space for new freq digit at correct position
	       NewCode=logic.Or(DigitSpace, movPARAM)                                        -- place digit
	       ipc.writeUW(codeloc, NewCode)                                                 -- update radio panel
            keypos=keypos+1                                                              --point to position 2 next

        elseif keypos==2 then
	       movPARAM=logic.Shl(ipcPARAM, 8)                                               -- move new digit to correct position
	       DigitSpace=logic.And(CurrCode , 0xF0FF)                                       -- create space for new freq digit at correct position
	       NewCode=logic.Or(DigitSpace, movPARAM)                                        -- place digit
	       ipc.writeUW(codeloc, NewCode)                                                 -- update radio panel
           keypos=keypos+1                                                               --point to position 3 next
	        
	    elseif keypos==3 then
	         movPARAM=logic.Shl(ipcPARAM,4)                                              -- move new digit to correct position
                      DigitSpace=logic.And(CurrCode , 0xFF0F)                            -- create space for new freq digit at correct position
	       NewCode=logic.Or(DigitSpace, movPARAM)                                        -- place digit
	       ipc.writeUW(codeloc, NewCode)                                                 -- update radio panel
             keypos=keypos+1                                                             --point to position 4 next

       elseif keypos==4 then
             DigitSpace=logic.And(CurrCode , 0xFFF0)                                    -- create space for new freq digit at correct position
	       NewCode=logic.Or(DigitSpace, ipcPARAM)                                       -- place digit
	       ipc.writeUW(codeloc, NewCode)                                                -- update radio panel
             keypos=keypos+1                                                            -- update keypos in case need to BkSpc
       end
   ipc.set("KEY_POS", keypos)                                                           --save keypos value for next iteration of program              
 end                                                                                    -- end transponder,  acr =SQK
                                                                                                                                                                                                                                               


