-- NpCsetIAS 14Nov2013
--Updated for FLight1 KA B200 and PMDG B777 1Feb15
--Al Klayton

tab="\t\t\t\t\t\t\t\t\t\t\t\t\t\t"   -- tab is used to position NpC "messages" along the green bar
acr = ipc.get("ACTIVE_RADIO")
ipc.set("KEY_POS", 1)
onoff = ipc.get("ONOFF")
aircraft_sel = ipc.get("CURR_AIRCRAFT")

if (not(onoff == nil) and onoff == "OFF") then
	return
end

--The following code allows the "normal" AP IAS key to do double duty as the AP Mode key for the A2A Cherokee 180

if aircraft_sel=="2" then                    -- is Cherokee 180 the selected a/c
    apMaster=ipc.readLvar("L:ApMaster")
    ipc.sleep(100)
    if apMaster~=1 then                      --is Cherokee AP on?
       ipc.writeSTR(0x3380, tab.." AP Not On")
       ipc.writeSW(0x32FA, 4)              -- display message on green bar for 4 sec
       return
    else
	 ipc.writeLvar("L:ApModeYokeSwitch", 1)   --toggle yoke mode switch to change AP modes
     ipc.sleep(100)
     ipc.writeLvar("L:ApModeYokeSwitch", 0)
	 ipc.sleep(100)
	 apModeSel = ipc.readLvar("L:ApMode")
	 ipc.sleep(100)
	 if apModeSel==1 then
	    apModeTxt="ST"
	 elseif
    	apModeSel==2 then
	    apModeTxt="HD"	
	 elseif
     	apModeSel==3 then
	    apModeTxt="Track Low" 
	 elseif
	    apModeSel==4 then
	    apModeTxt="Track High"
	 end	
	 	if apModeSel==nil or apModeSel < 1 or apModeSel > 4 then   
	       ipc.writeSTR(0x3380, tab.."No AP Mode Active")          -- display on green bar 
		else   
           ipc.writeSTR(0x3380, tab.."AP MODE "..apModeTxt)  -- display on green bar
        end		   
     ipc.writeSW(0x32FA, 4)
	 return
 end                          --end if Cherokee AP on
end                           --end of code for Cherokee AP Mode button
------------------------------------------------------------------------------------------------

if acr~= "AP_KTS" and acr~= "AP_MACH" then
acr = "AP_MACH"                                 -- init for IAS script, note covers case of acr=nil, will get toggled to AP_Knots below as initial setting
end

if aircraft_sel =="3" then
   ipc.writeSTR(0x3380, tab.."KA B200 AP Speed Not Implemented ")
   ipc.writeSW(0x32FA, 4)
   return
end
if ipcPARAM == 1 or aircraft_sel =="3" then      --ipcPARAM =0 for toggle, =1 for AP_KTS only, =2 for MACH only; aircraft_sel=2 for KA B200                                     
	acr = "AP_KTS"                              
    ipc.writeSTR(0x3380, tab.."IAS in KNOTS, ###")	
  elseif ipcPARAM == 2  then                      --Mach only case
	acr = "AP_MACH" 
	if aircraft_sel=="5" then          -- B777 a/c
	  ipc.writeSTR(0x3380, tab.."Use Mouse in VC to Set Mach #")    -- because currently can't find way to read B777 MACH # from speed window 
	else
	  ipc.writeSTR(0x3380, tab.."IAS in MACH, #.##")
	end  
    elseif acr=="AP_MACH" then
	  spdMode=ipc.readLvar("L:ngx_SPDmode")
	  ipc.sleep(10)
	  if spdMode==2 and aircraft_sel=="5" then      --B777 a/c
	     acr = "AP_KTS"
		 ipc.set("ACTIVE_RADIO",  acr)
	    ipc.writeSTR(0x3380, tab.."To Enter Knots Change MCP Airspeed Window to KNOTS")
		 ipc.writeSW(0x32FA, 4)   --display message 4 sec
         return	  
	  end	 
     acr = "AP_KTS"                              -- toggle mode; switch to other speed mode
 	 ipc.writeSTR(0x3380, tab.."IAS in KNOTS, ###")
	elseif acr=="AP_KTS" then                     -- was knots the previous setting?
        acr="AP_MACH"                             -- toggle mode; switch to other speed mode
 	    if aircraft_sel=="5" then 
		ipc.writeSTR(0x3380, tab.."Use Mouse in VC to Set Mach #")    -- because currently can't find way to read B777 MACH # from speed window 
		else
 	     ipc.writeSTR(0x3380, tab.."IAS in MACH, #.##")
        end 
end
ipc.set("ACTIVE_RADIO",  acr)     
ipc.writeSW(0x32FA, 4)                      --display new active airspeed on green bar for 4 sec


